/*
 * FileLastModifiedFilter class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util.file;

import java.io.File;
import java.io.FileFilter;
import java.util.Date;

/**
 * ファイルの最終更新日を条件とするファイル・フィルタ・クラス。
 *
 * @author  佐藤隆之.
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:46 $
 */
public class FileLastModifiedFilter implements FileFilter
{
  /** ファイル最終更新日の条件範囲の開始値。 */
  private Date modifiedAfter_ = null;

  /** ファイル最終更新日の条件範囲の終了値。 */
  private Date modifiedBefore_ = null;

  /**
   * ファイル最終更新日の範囲を引数にとるコンストラクタ。
   * <br>
   * ヌルを設定した場合は、その値を条件として使用しない。
   * <br>
   * 引数がいずれもヌルでなく、範囲の開始値と終了値の指定が逆だった場合は、
   * 入れ替えて設定する。
   *
   * @param  start ファイル最終更新日の範囲の開始値。 
   * @param  end ファイル最終更新日の範囲の終了値。 
   */
  public FileLastModifiedFilter(Date start, Date end)
  {
    if (start != null && end != null) {
      if (start.before(end)) {
        modifiedAfter_ = start;
        modifiedBefore_ = end;
      }
      else {
        modifiedAfter_ = end;
        modifiedBefore_ = start;
      }
    }
    else {
      modifiedAfter_ = start;
      modifiedBefore_ = end;
    }
  }

  /**
   * 指定されたファイルの最終更新日時が、このオブジェクトの示す最終更新日時の
   * 範囲に該当する（境界値を含む）かどうかを判定する。
   *
   * @param  file 判定対象のファイル。
   * @return ファイルの更新日時が該当する場合は<tt>true</tt>を返す。
   * @throws AssertionError 引数がヌルの場合（デバッグ・モードのみ）。
   */
  public boolean accept(File file)
  {
    assert (file != null) : "@param:file is null.";

    if (modifiedAfter_ != null) {
      if (file.lastModified() < modifiedAfter_.getTime()) {
        return false;
      }
    }

    if (modifiedBefore_ != null) {
      if (file.lastModified() > modifiedBefore_.getTime()) {
        return false;
      }
    }

    return true;
  }
}

